package manager;

import brs.*;
import brs.visitor.*;

public class Allocator implements IAllocator {
    
    static class Range implements Comparable<Range>{
        int _index;
        int _count;
        
        public Range(int ix, int c) {
            _index = ix;
            _count = c;
        }
        
        public int compareTo(Range rhs) {
            return _index - rhs._index; 
        }
        
        public String toString() {
            return "(" + _index + ", " + _count + ")";
        }
        
        public boolean contains(Range other) {
            return (_index <= other._index) && 
                (other._index + other._count <= _index + _count);
        }
    }  
    
    /**
     * BST Tree holding contiguous blocks of available memory.
     */
    private BiTree _memory;
    
    private IVisitor _inserter = new BSTInserter();
    private IVisitor _deleter = new BSTDeleter();
    
    /**
     * Allocate memory.
     * STUDENTS TO COMPLETE.
     */
    private IVisitor _alloc = new IVisitor() {
        /**
         * There is no memory left to allocate.
         * @param count[0] memory size to be allocated.
         * @return Integer 
         */
        public Object emptyCase(BiTree host, Object... count) {
            // STUDENTS TO COMPLETE
            return 0;
        }
        
        /**
         * Returns the starting index of the first available contiguous group of
         * unused locations of size "count" in memory and updates the index and
         * count of the appropriate Range object.
         * 
         * If there is no sufficiently large contiguous group of unused locations, 
         * then returns -1.
         * @param count[0] memory size to be allocated.
         * @return Integer
         */        
        public Object nonEmptyCase(BiTree host, Object... count) {
            // STUDENTS TO COMPLETE
            return 0;
        }    
    };
    
    /**
     * Free memory by inserting the appropriate block of contiguous memory
     * into the BiTree _memory and merging the appropriate Range objects to
     * obtain the largest possible block of contiguous memory.
     * The inputs are guaranteed to be valid.
     * 
     * STUDENTS TO COMPLETE BY WRITING PSEUDO-CODE AS COMMENTS
     * WORKING CODE IS NOT REQUIRED.
     */
    private IVisitor _freer = new IVisitor() {
        
        /**
         * What do we do here?
         * @param block[0] Integer index guaranteed to be valid
         * @param block[1] Integer count guaranteed to be valid
         */
        public Object emptyCase(BiTree host, Object... block) {
            // STUDENTS TO WRITE PSEUDO-CODE.
            return null;
        }
        
        /**
         * Insert the appropriate Range into the _memory BiTree.
         * Appropriate adjoining Range objects are expanded to include the 
         * newly freed memory. For example, if the allocator hold Range objects 
         * (index: 5000, count: 1000) and (index: 6500, count: 500) and the 
         * memory at index 6000 of count 500 is freed, the two previous Range 
         * objects are replaced by a single Range object (index: 5000, count: 2000).
         * @param block[0] Integer index guaranteed to be valid
         * @param block[1] Integer count guaranteed to be valid
         */
        public Object nonEmptyCase(BiTree host, Object... block) {
            // STUDENTS TO WRITE PSEUDO-CODE.
            return null;
        }
    };
    
    public Allocator(int base, int size) {
        _memory = new BiTree();
        _memory.insertRoot(new Range(base, size));
    }
    
    public int allocate(int count) {
        return (Integer)_memory.execute(_alloc, count);
    }
    
    public void free(int index, int count) {
        _memory.execute(_freer, index, count);
    }
    
    public String toString() {
        return _memory.toString();
    }
    
    /**
     * For testing allocate without using free.
     */
    public void insert(int index, int count) {
        _memory.execute(_inserter, new Range(index, count));
    }}